Next.js starter your AI actually understands. Ship internal tools in days not weeks. Pre-order $199 $499 → [Get it now]

How to implement dark mode in Vue

Dark mode improves user experience by reducing eye strain in low-light environments and has become an essential feature for modern web applications. As the creator of CoreUI, a widely used open-source UI library, I’ve implemented dark mode in Vue applications throughout my 11 years of frontend development. The most effective approach is using Vue 3 Composition API with reactive state and CSS custom properties for theme switching. This method enables smooth theme transitions, persists user preferences, and maintains clean separation between logic and styling.

Use reactive state to track dark mode, toggle theme class on root element, and define CSS variables for light and dark themes.

<script setup>
import { ref, onMounted, watch } from 'vue'

const isDarkMode = ref(false)

const toggleDarkMode = () => {
  isDarkMode.value = !isDarkMode.value
}

watch(isDarkMode, (newValue) => {
  if (newValue) {
    document.documentElement.classList.add('dark-mode')
    localStorage.setItem('theme', 'dark')
  } else {
    document.documentElement.classList.remove('dark-mode')
    localStorage.setItem('theme', 'light')
  }
})

onMounted(() => {
  const savedTheme = localStorage.getItem('theme')
  isDarkMode.value = savedTheme === 'dark'
})
</script>

<template>
  <div class='app'>
    <button @click='toggleDarkMode'>
      {{ isDarkMode ? '☀️ Light Mode' : '🌙 Dark Mode' }}
    </button>
    <h1>Welcome to the App</h1>
    <p>This content changes with the theme</p>
  </div>
</template>

<style>
:root {
  --bg-color: #ffffff;
  --text-color: #333333;
  --card-bg: #f5f5f5;
}

.dark-mode {
  --bg-color: #1a1a1a;
  --text-color: #ffffff;
  --card-bg: #2d2d2d;
}

body {
  background-color: var(--bg-color);
  color: var(--text-color);
  transition: background-color 0.3s, color 0.3s;
}

.app {
  max-width: 800px;
  margin: 0 auto;
  padding: 2rem;
}

button {
  background-color: var(--card-bg);
  color: var(--text-color);
  border: none;
  padding: 0.75rem 1.5rem;
  border-radius: 0.5rem;
  cursor: pointer;
}
</style>

Here the isDarkMode ref tracks the current theme state reactively. The watch function responds to theme changes by adding or removing the dark-mode class on the document root element and persisting the preference to localStorage. The onMounted lifecycle hook restores the saved theme preference when the component loads. CSS custom properties (–bg-color, –text-color) define theme colors that update automatically when the dark-mode class is applied. The transition property creates smooth color changes when switching themes.

Best Practice Note:

This is the dark mode implementation pattern we use in CoreUI Vue components for consistent theming across enterprise applications. Consider detecting system preference with window.matchMedia(’(prefers-color-scheme: dark)’) to set initial theme, use provide/inject to share theme state across deeply nested components, and implement CSS transitions on color properties for smooth visual transitions between themes.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Next.js starter your AI actually understands. Ship internal tools in days not weeks. Pre-order $199 $499 → [Get it now]

How to implement dark mode in React

Implementing dark mode enhances user experience by providing eye-friendly viewing options and modern application aesthetics. As the creator of CoreUI with 25 years of development experience, I’ve implemented dark mode in numerous enterprise applications. The most robust approach uses React Context API for global theme state management combined with CSS custom properties for seamless theme switching. This method ensures consistent theming across all components while maintaining user preferences.

Use Context API with CSS custom properties and localStorage for persistent dark mode functionality.

import React, { createContext, useContext, useEffect, useState } from 'react'

const ThemeContext = createContext()

export const ThemeProvider = ({ children }) => {
  const [isDark, setIsDark] = useState(() => {
    const saved = localStorage.getItem('theme')
    return saved === 'dark'
  })

  useEffect(() => {
    document.documentElement.setAttribute('data-theme', isDark ? 'dark' : 'light')
    localStorage.setItem('theme', isDark ? 'dark' : 'light')
  }, [isDark])

  const toggleTheme = () => setIsDark(!isDark)

  return (
    <ThemeContext.Provider value={{ isDark, toggleTheme }}>
      {children}
    </ThemeContext.Provider>
  )
}

export const useTheme = () => {
  const context = useContext(ThemeContext)
  if (!context) throw new Error('useTheme must be used within ThemeProvider')
  return context
}

// Usage in component
const DarkModeToggle = () => {
  const { isDark, toggleTheme } = useTheme()

  return (
    <button onClick={toggleTheme}>
      {isDark ? '☀️ Light Mode' : '🌙 Dark Mode'}
    </button>
  )
}

This implementation creates a theme context that manages dark mode state globally. The useEffect hook updates the document’s data-theme attribute and persists the preference in localStorage. CSS custom properties can then target [data-theme="dark"] for styling. The custom hook provides a clean interface for components to access and modify theme state.

Best Practice Note:

This is the same reliable theming approach we use in CoreUI components for consistent dark mode support. Define your color tokens as CSS custom properties in the root scope and leverage the data-theme attribute for seamless theme transitions.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
How to conditionally add attributes to React components
How to conditionally add attributes to React components

How to Conditionally Add a Property to an Object in JavaScript
How to Conditionally Add a Property to an Object in JavaScript

How to Clone an Object in JavaScript
How to Clone an Object in JavaScript

How to Hide Scrollbar with CSS
How to Hide Scrollbar with CSS

Answers by CoreUI Core Team